/******************************************************************************
  Target Script for Cortex-M3

  Copyright (c) 2007 Rowley Associates Limited.

  This file may be distributed under the terms of the License Agreement
  provided with this software.

  THIS FILE IS PROVIDED AS IS WITH NO WARRANTY OF ANY KIND, INCLUDING THE
  WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 ******************************************************************************/

function Reset()
{
  if (TargetInterface.implementation() == "j-link")
    {
      TargetInterface.resetAndStop(1000);
      return;
    }
  TargetInterface.pokeWord(0xE000EDF0, 0xA05F0003); // set C_HALT and C_DEBUGEN in DHCSR      
  TargetInterface.waitForDebugState(1000);
  TargetInterface.pokeWord(0xE000EDFC, 0x1); // set VC_CORERESET in DEMCR
  TargetInterface.pokeWord(0xE000ED0C, 0x05FA0004); // set SYSRESETREQ in AIRCR
  TargetInterface.waitForDebugState(1000);
}

function SRAMReset()
{
  Reset();
}

function FLASHReset()
{
  Reset();
}

function GetPartName()
{ 
  var PartName;
  switch (TargetInterface.peekWord(0x10000100))
    {
      case 0x51822:
        PartName = "nRF51822";
        break;
      case 0x51422:
        PartName = "nRF51422";
        break;
      case 0x52000:
        PartName = "nRF52000";
        break;
    }
  if (TargetInterface.peekWord(0x1000010C)==16 && TargetInterface.peekWord(0x10000110)==256)
    PartName += "_xxAA";
  else if (TargetInterface.peekWord(0x1000010C)==16 && TargetInterface.peekWord(0x10000110)==128)
    PartName += "_xxAB";
  else if (TargetInterface.peekWord(0x1000010C)==32 && TargetInterface.peekWord(0x10000110)==256)
    PartName += "_xxAB";
  return PartName;
}
